<?php
  session_start();

  include 'config.php';
  require 'aws-sdk/aws-autoloader.php';
  use Aws\Ses\SesClient;
  /* Reference to the ses client */
  $client = SesClient::factory(array(
    'version' => 'latest',
    'region'  => $aws_region,
    'credentials' => array(
      'key' => $aws_access_key_id,
      'secret'  => $aws_secret_access_key,
    )
  ));
  date_default_timezone_set('America/Mexico_City');
  $status = '';
  if ( isset($_POST['captcha']) && ($_POST['captcha']!="") ){
    // Validation: Checking entered captcha code with the generated captcha code
    if(strcasecmp($_SESSION['captcha'], $_POST['captcha']) != 0){
    // Note: the captcha code is compared case insensitively.
    // if you want case sensitive match, update the check above to strcmp()
      echo "<p class='errormsg'>El captcha es inválido.</p> ";
      exit();
    }
  }

/*

  if(strcasecmp($_SESSION['captcha'], $_POST['captcha']) != 0){
    // Note: the captcha code is compared case insensitively.
    // if you want case sensitive match, update the check above to strcmp()
      echo "<p class='errormsg'>El captcha es inválido.</p> ";
      exit();
    }

    

    echo $_SESSION['captcha'];

    if($_POST['captcha'] == "ind3*"){

    }
    else{

      echo "<p class='errormsg'>El captcha es inválido.</p> ";
      exit();
    }

    */
  $correo = trim($_POST['email']);
  $correo = strip_tags($correo);
  $correo = htmlspecialchars($correo);

  $pass = trim($_POST['pass']);
  $pass = strip_tags($pass);
  $pass= htmlspecialchars($pass);
  $hash =  hash('sha256', $pass);

  if(strlen($correo) > 5 && strlen($pass) > 5){
    $curl = curl_init();
    curl_setopt_array($curl, array(
        CURLOPT_URL => $endpoint_graph_cms,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',
        CURLOPT_POSTFIELDS =>'{"query":"query MyQuery {\\r\\n  usuariosAdmin(where: {password: \\"'.$hash.'\\", email: \\"'.$correo.'\\"}) {\\r\\n    id\\r\\n  }\\r\\n}\\r\\n","variables":{}}',
        CURLOPT_HTTPHEADER => array(
          'Content-Type: application/json',
          'Cookie: __cfduid=da2693cdfd39b7377a8a05e305da45b8f1613001694'
        ),
    ));
      
    $response = curl_exec($curl);
    curl_close($curl);
    //echo $response;

    $jsonrespuesta = json_decode($response, true);
    $id = $jsonrespuesta['data']['usuariosAdmin'][0]['id'];
    //echo $id;
    $sucess = "<p class='successmsg'>Inicio de sesión correcto, por favor espera un momento.</p><script>loginSuccess();</script>";
    $fail = "<p class='errormsg'>Credenciales no válidas. Verifica usuario y contraseña.</p> ";

    if(strlen($id)>10){
      $_SESSION['user'] = $correo;
      //setcookie("persistID", "$correo", time() + (20 * 2 * 12 * 60 * 60), "/", null, true, true);
      setcookie("persistID", "$correo", time()+ (1 * 2 * 12 * 60 * 60), '/');

      function cvf_ps_generate_random_code($length=10) {
        $string = '';
        $characters = "123456789ABCDEFHJKLMNPRTVWXYZ";
        for ($p = 0; $p < $length; $p++) {
            $string .= $characters[mt_rand(0, strlen($characters)-1)];
        }
        return $string;
      }
        
      $token = cvf_ps_generate_random_code(6);
      $generado = time();

      $curl = curl_init();

      curl_setopt_array($curl, array(
        CURLOPT_URL => $endpoint_graph_cms,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',
        CURLOPT_POSTFIELDS =>'{"query":"mutation MyMutation {\\r\\n  createCodigoDobleFactor(data: {codigo: \\"'.$token.'\\", correo: \\"'.$correo.'\\", fuente: \\"CMS\\", generado: \\"'.$generado.'\\", localizations: {create: {data: {codigo: \\"'.$token.'\\", correo: \\"'.$correo.'\\", generado: \\"'.$generado.'\\", fuente: \\"CMS\\"}, locale: es_MX}}}) {\\r\\n    id\\r\\n  }\\r\\n}\\r\\n","variables":{}}',
        CURLOPT_HTTPHEADER => array(
          'Content-Type: application/json',
          'Cookie: __cfduid=da2693cdfd39b7377a8a05e305da45b8f1613001694'
        ),
      ));

      $response = curl_exec($curl);
      curl_close($curl);
      //echo $response;
      $EmailEnvio = $correo;

      if(strlen($EmailEnvio)>5){

        $to = $EmailEnvio; 
        $email = 'noreply@arjm.xyz';
      
        $email_subject = "Clave de acceso | INDEVAL CMS"; //Asunto


        //ENVIAR CORREO CON AMAZON SES

        //Now that you have the client ready, you can build the message
        $msg = array();
        $msg['Source'] = "indeval@grupobmv.com.mx";
        //ToAddresses must be an array
        $msg['Destination'] = array(
          'ToAddresses' => array($correo)
        );

        //Next we will form the body of the email:
        $msg['Message'] = array(
            // Subject is required
            'Subject' => array(
              // Data is required
              'Data' => $email_subject,
              'Charset' => 'UTF-8',
          ),
          // Body
          'Body' => array(
            'Text' => array(
            // Data
            'Data' => $email_subject,
            'Charset' => 'UTF-8',
            ),
            'Html' => array(
            // Data is required
            'Data' => '
            <body style="background-color:#2b4365;">
              <table border=0 width="90%" style="border: 2px solid #2b4365; font-family: Century gothic, Helvetica, sans-serif;color:#2b4365;font-size: 15px;background-color: #ebebee;max-width: 700px;padding: 40px 20px;border-radius: 20px;position: relative;margin: 0 auto;top: 1em; text-align:center;">
                    <tr><td align="center">
                    <img src="https://indeval-webdocs-publico-01122020.s3.amazonaws.com/img/indeval_logo.png" alt="Indeval" style="width:200px; margin: 0px auto 20px;"/>
                    </td></tr>
  
                    <tr><td align="center" height="200">
                    <h3 style="color:#2b4365; foont-weight:bold; text-align:center;">CÓDIGO DE ACCESO</h3>
            
                    <div style="text-align:center; color:#444; margin-top:20px; width:80%;background-color: #eee;
                    border-radius: 30px;
                    padding: 30px;"><b>Tú código de acceso es:</b><br>
                    <h4 style="font-size:40px; text-align:center;"> '.$token.'</h4>
                    <br /><br />
                    <p>Recuerda que este código es de un solo uso y expirará <b>10 minutos</b> después de ser generado. Si necesitas un nuevo código, puedes solicitarlo desde la página de acceso del CMS.</p>
                    
                    </td></tr>							 
              </table>
              <p>Fecha y Hora de envío: '.date("d-m-Y h:i:s").'</p>
            </body>
          ',
            'Charset' => 'UTF-8',
            ),
          )
        );

        //Now you are all set. You call sendEmail to send the email:

        try{
        $result = $client->sendEmail($msg);

        //Msg id from AWS. Can be used for tracking.
        $msg_id = $result->get('MessageId');
        //echo("MessageId: $msg_id");

        //view sample output
        //print_r($result);
        } catch (Exception $e) {
        //Exception Caught.
        //echo($e->getMessage());
        echo "<p class='errormsg'>Ocurrió un error al enviar el correo, intente nuevamente en unos minutos.</p> ";
        }

        if(strlen($msg_id)>5){
          echo $sucess;
        }
        else{
          echo "<p class='errormsg'>Ocurrió un error al enviar el correo, intente nuevamente en unos minutos.</p> ";
        }

        //Print the result to check if it is successful
        //print_r($result);

        //termina mail SES
        
      }
      else{
        echo $fail;
      }
    }

    else{

      echo "<p class='errormsg'>Credenciales no válidas. Verifica usuario y contraseña.</p> ";

    }
  }